# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import playerlib
import popuplib
import cmdlib
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

filters = ['#spec']

# '''''''''''''''''''''' # Languages # ''''''''''''''''''''' #
langDir     = es.getAddonPath('sam') + '/langs/pcontrol/'
actionsText = langlib.Strings(langDir + 'actions.ini')
chattag = func.commonText('kick', None, None)
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load(): cmdlib.registerSayCommand('!kick', kickCMD, 'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload(): cmdlib.unregisterSayCommand('!kick')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def kickCMD(userid, args):
	if admins.isAdmin(es.getplayersteamid(userid)) == True and admins.checkAccess(es.getplayersteamid(userid), 'Kick') == True: 
			if args:
				if len(args) > 1:
					tokens = {'num':len(args)}
					for target in args:
						target = playerlib.getPlayer(es.getuserid(target))
						if admins.checkImmunity(es.getplayersteamid(userid), target.steamid):
							tokens['num'] += 1
							target.kick()
					if tokens['0'] != 0:
						for ply in es.getUseridList(): func.tell(ply, actionsText('kicked_2', tokens, func.getLang()), '#green' + chattag.upper())
				else:
					target = playerlib.getPlayer(es.getuserid(args[0]))
					if admins.checkImmunity(es.getplayersteamid(userid), target.steamid): kickTarget(target)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(admin, target):
	if admins.checkImmunity(admin.steamid, target.steamid): kickTarget(target)
	else:
		block = es.import_addon('sam/base/pcontrol')
		block.modulePopup(admin)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def kickTarget(target, reason = None):
	target.kick(reason)
	tokens = {'target':target.name}
	for ply in es.getUseridList(): func.tell(ply, actionsText('kicked', tokens, func.getLang()), '#green' + chattag.upper())

# ============================================================================================================================================================= #